apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "nhost.fullname" . }}-dashboard
  labels:
    {{- include "nhost.labels" . | nindent 4 }}
    app.kubernetes.io/component: dashboard
spec:
  {{- if not .Values.dashboard.autoscaling.enabled }}
  replicas: {{ .Values.dashboard.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "nhost.selectorLabels" . | nindent 6 }}
      app.kubernetes.io/component: dashboard
  template:
    metadata:
      {{- with .Values.podAnnotations }}
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "nhost.selectorLabels" . | nindent 8 }}
        app.kubernetes.io/component: dashboard
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "nhost.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      initContainers:
      - name: wait-hasura
        image: curlimages/curl:7.84.0
        command:
          - 'sh'
          - '-c'
          - |
            until [ "$(curl -s -w '%{http_code}' -o /dev/null "${HASURA_ENDPOINT}")" -eq 200 ]
            do
              echo \"waiting for hasura on ${HASURA_ENDPOINT}\
              sleep 1
            done
            echo \"Successfully tested ${HASURA_ENDPOINT}\
        env:
        - name: HASURA_ENDPOINT
          value: http://{{ include "nhost.fullname" . }}-graphql/healthz
      containers:
      - name: {{ .Chart.Name }}
        securityContext:
          {{- toYaml .Values.securityContext | nindent 12 }}
        image: "{{ .Values.dashboard.image.repository }}:{{ .Values.dashboard.image.tag }}"
        imagePullPolicy: {{ .Values.dashboard.image.pullPolicy }}
        ports:
          - name: http
            containerPort: 3000
            protocol: TCP
        livenessProbe:
          httpGet:
            path: /
            port: http
          periodSeconds: 10
          failureThreshold: 3
        readinessProbe:
          httpGet:
            path: /
            port: http
          periodSeconds: 10
          failureThreshold: 3
        resources:
          {{- toYaml .Values.dashboard.resources | nindent 12 }}
        env:
        - name: NEXT_TELEMETRY_DISABLED
          value: "1"
        - name: NEXT_PUBLIC_ENV
          value: {{ .Values.dashboard.env }}
        - name: NEXT_PUBLIC_NHOST_PLATFORM
          value: "false"
        {{- if .Values.global.ingress.enableTls }}
        - name: NEXT_PUBLIC_NHOST_AUTH_URL
          value: https://{{ .Values.auth.hostname }}/v1/auth
        - name: NEXT_PUBLIC_NHOST_FUNCTIONS_URL
          value: https://{{ .Values.graphql.hostnames.api }}/v1/functions
        - name: NEXT_PUBLIC_NHOST_GRAPHQL_URL
          value: https://{{ .Values.graphql.hostnames.api }}/v1/graphql
        - name: NEXT_PUBLIC_NHOST_STORAGE_URL
          value: https://{{ .Values.graphql.hostnames.api }}/v1/storage
        - name: NEXT_PUBLIC_NHOST_HASURA_CONSOLE_URL
          value: https://{{ .Values.graphql.hostnames.console }}
        - name: NEXT_PUBLIC_NHOST_HASURA_API_URL
          value: https://{{ .Values.graphql.hostnames.api }}
        {{- else }}
        - name: NEXT_PUBLIC_NHOST_AUTH_URL
          value: http://{{ .Values.auth.hostname }}/v1/auth
        - name: NEXT_PUBLIC_NHOST_FUNCTIONS_URL
          value: http://{{ .Values.graphql.hostnames.api }}/v1/functions
        - name: NEXT_PUBLIC_NHOST_GRAPHQL_URL
          value: http://{{ .Values.graphql.hostnames.api }}/v1/graphql
        - name: NEXT_PUBLIC_NHOST_STORAGE_URL
          value: http://{{ .Values.graphql.hostnames.api }}/v1/storage
        - name: NEXT_PUBLIC_NHOST_HASURA_CONSOLE_URL
          value: http://{{ .Values.graphql.hostnames.console }}
        - name: NEXT_PUBLIC_NHOST_HASURA_API_URL
          value: http://{{ .Values.graphql.hostnames.api }}
        envFrom:
        - configMapRef:
            name: {{ include "nhost.fullname" $ }}-env
        - secretRef:
            name: {{ include "nhost.fullname" $ }}-env
        volumeMounts:
        - name: tmp
          mountPath: /app/dashboard/public
      volumes:
      - name: tmp
        emptyDir:
          medium: Memory
          sizeLimit: 50Mi
      {{- end }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
